'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _Object$getPrototypeOf = _interopDefault(require('babel-runtime/core-js/object/get-prototype-of'));
var _classCallCheck = _interopDefault(require('babel-runtime/helpers/classCallCheck'));
var _createClass = _interopDefault(require('babel-runtime/helpers/createClass'));
var _possibleConstructorReturn = _interopDefault(require('babel-runtime/helpers/possibleConstructorReturn'));
var _inherits = _interopDefault(require('babel-runtime/helpers/inherits'));
var React = _interopDefault(require('react'));

function date(language) {
  var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var formatter = new Intl.DateTimeFormat(language, format);
  return function (value) {
    return formatter.format(value);
  };
}

function number(language) {
  var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var formatter = new Intl.NumberFormat(language, format);
  return function (value) {
    return formatter.format(value);
  };
}

function createFormat(formatFunction) {
  return function (_React$Component) {
    _inherits(_class2, _React$Component);

    function _class2() {
      _classCallCheck(this, _class2);

      return _possibleConstructorReturn(this, (_class2.__proto__ || _Object$getPrototypeOf(_class2)).apply(this, arguments));
    }

    _createClass(_class2, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            value = _props.value,
            format = _props.format,
            i18n = _props.i18n;

        var formatter = formatFunction(i18n.language, format);
        return React.createElement(
          'span',
          null,
          formatter(value)
        );
      }
    }]);

    return _class2;
  }(React.Component);
}

var DateFormat = createFormat(date);
var NumberFormat = createFormat(number);

exports.DateFormat = DateFormat;
exports.NumberFormat = NumberFormat;
exports.date = date;
exports.number = number;
